---
include:
  - project: 'repos/releng/kokkuri'
    file: 'includes/images.yaml'

stages:
  - build
  - publish
  - deploy

variables:
  GIT_SUBMODULE_STRATEGY: recursive
  FUNCTION_ORCHESTRATOR_REF: ""
  FUNCTION_ORCHESTRATOR_TAG: ""

build:
  stage: build
  extends: .kokkuri:build-image
  variables:
    BUILD_VARIANT: serve

publish:
  stage: publish
  extends: .kokkuri:build-and-publish-image
  variables:
    BUILD_VARIANT: serve
    PUBLISH_IMAGE_TAG: ${CI_COMMIT_SHORT_SHA}
    PUBLISH_IMAGE_EXTRA_TAGS: latest
  tags:
    - trusted
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_COMMIT_REF_PROTECTED


deploy:
  stage: deploy
  image:
    name: docker-registry.wikimedia.org/repos/abstract-wiki/ci-images/helm
    entrypoint: [""]
  script:
    - kubectl config use-context repos/qte/catalyst/prototype-charts:prototype-control-plane-2
    - git clone https://gitlab.wikimedia.org/repos/qte/catalyst/prototype-charts.git
    - |
      helm upgrade --install --namespace control-plane --create-namespace \
        prototype-ui ./prototype-charts/prototype-ui \
        --set image.tag=${CI_COMMIT_SHORT_SHA} --set ingress.hostname=catalyst.wmcloud.org
  tags: [ catalyst-prototype-control-plane-2 ]
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_COMMIT_REF_PROTECTED
